#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <syslog.h>
#include <unistd.h>

#define DAEMONDIRECTORY "/tmp"
#define BUFFER_SIZE 16384
#define DEFAULT_SERV_PORT 2222

void daemonize(void);
void disconnect(int socket);
void fdprintf(int fd, char *format, ...);
void fdset_copy(fd_set *from, fd_set *to);
int fdset_max(fd_set x);
void greet(int fd, struct sockaddr_in *addr);
void main_loop(unsigned short serv_port);
int make_conn_socket(unsigned short port);
void process(int socket, int len, char *data);
void shut_down(void);
int socket_read(int socket, char **bufaddr);
void user_startup(void);
void vfdprintf(int fd, char *format, va_list ap);

